Index: /LMDZ5/branches/testing/libf/phylmd/microphys_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/microphys_mod.F90	(revision 2056)
+++ /LMDZ5/branches/testing/libf/phylmd/microphys_mod.F90	(revision 2056)
@@ -0,0 +1,31 @@
+!
+! $Header$
+!
+MODULE microphys_mod
+
+CONTAINS
+!*******************************************************************
+
+FUNCTION icefrac_lsc(temp, tmin, tmax, nexpo)
+  IMPLICIT NONE
+  !
+  ! Compute the ice fraction 1-xliq (see e.g.
+  ! Doutriaux-Boucher & Quaas 2004, section 2.2.)
+  !
+  ! (JBM 3/14)
+  REAL :: icefrac_lsc ! ice fraction 
+  REAL :: temp ! temperature
+  REAL :: tmin ! if T < Tmin, the cloud is only made of water ice
+  REAL :: tmax ! if T > Tmax, the cloud is only made of liquid water
+  REAL :: nexpo ! controls the sharpness of the transition
+
+  icefrac_lsc = 1.0 - (temp-tmin) / (tmax-tmin)
+  icefrac_lsc = MIN(MAX(icefrac_lsc,0.0),1.0)
+  icefrac_lsc = icefrac_lsc**nexpo
+
+  RETURN
+END FUNCTION icefrac_lsc
+
+!*******************************************************************
+!
+END MODULE microphys_mod
Index: /LMDZ5/branches/testing/libf/phylmd/newmicro.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/newmicro.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/newmicro.F90	(revision 2056)
@@ -12,4 +12,5 @@
     reffclwc, cldnvi, lcc3d, lcc3dcon, lcc3dstra
   USE phys_state_var_mod, ONLY: rnebcon, clwcon
+  USE microphys_mod ! cloud microphysics (JBM 3/14)
   IMPLICIT NONE
   ! ======================================================================
@@ -106,7 +107,11 @@
   PARAMETER (seuil_neb=0.001)
 
-  INTEGER nexpo ! exponentiel pour glace/eau
-  PARAMETER (nexpo=6)
-  ! PARAMETER (nexpo=1)
+! JBM (3/14) nexpo is replaced by exposant_glace
+! INTEGER nexpo ! exponentiel pour glace/eau
+! PARAMETER (nexpo=6)
+! PARAMETER (nexpo=1)
+! if iflag_t_glace=0, the old values are used:
+  REAL, PARAMETER :: t_glace_min_old = 258.
+  REAL, PARAMETER :: t_glace_max_old = 273.13
 
   REAL rel, tc, rei
@@ -180,18 +185,35 @@
   reice_pi = 0.
 
-  DO k = 1, klev
-    DO i = 1, klon
-      ! -layer calculation
-      rhodz(i, k) = (paprs(i,k)-paprs(i,k+1))/rg ! kg/m2
-      zrho(i, k) = pplay(i, k)/t(i, k)/rd ! kg/m3
-      dh(i, k) = rhodz(i, k)/zrho(i, k) ! m
-      ! -Fraction of ice in cloud using a linear transition
-      zfice(i, k) = 1.0 - (t(i,k)-t_glace_min)/(t_glace_max-t_glace_min)
-      zfice(i, k) = min(max(zfice(i,k),0.0), 1.0)
-      ! -IM Total Liquid/Ice water content
-      xflwc(i, k) = (1.-zfice(i,k))*pqlwp(i, k)
-      xfiwc(i, k) = zfice(i, k)*pqlwp(i, k)
-    END DO
-  END DO
+  IF (iflag_t_glace.EQ.0) THEN
+    DO k = 1, klev
+      DO i = 1, klon
+        ! -layer calculation
+        rhodz(i, k) = (paprs(i,k)-paprs(i,k+1))/rg ! kg/m2
+        zrho(i, k) = pplay(i, k)/t(i, k)/rd ! kg/m3
+        dh(i, k) = rhodz(i, k)/zrho(i, k) ! m
+        ! -Fraction of ice in cloud using a linear transition
+        zfice(i, k) = 1.0 - (t(i,k)-t_glace_min_old)/(t_glace_max_old-t_glace_min_old)
+        zfice(i, k) = min(max(zfice(i,k),0.0), 1.0)
+        ! -IM Total Liquid/Ice water content
+        xflwc(i, k) = (1.-zfice(i,k))*pqlwp(i, k)
+        xfiwc(i, k) = zfice(i, k)*pqlwp(i, k)
+      END DO
+    END DO
+  ELSE ! of IF (iflag_t_glace.EQ.0)
+    DO k = 1, klev
+      DO i = 1, klon
+        ! -layer calculation
+        rhodz(i, k) = (paprs(i,k)-paprs(i,k+1))/rg ! kg/m2
+        zrho(i, k) = pplay(i, k)/t(i, k)/rd ! kg/m3
+        dh(i, k) = rhodz(i, k)/zrho(i, k) ! m
+        ! JBM: icefrac_lsc is now a function contained in microphys_mod
+        zfice(i, k) = icefrac_lsc(t(i,k), t_glace_min, &
+                                  t_glace_max, exposant_glace)
+        ! -IM Total Liquid/Ice water content
+        xflwc(i, k) = (1.-zfice(i,k))*pqlwp(i, k)
+        xfiwc(i, k) = zfice(i, k)*pqlwp(i, k)
+      END DO
+    END DO
+  ENDIF
 
   IF (ok_cdnc) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/nuage.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/nuage.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/nuage.F90	(revision 2056)
@@ -5,4 +5,5 @@
     cldtaupi, re, fl)
   USE dimphy
+  USE microphys_mod ! cloud microphysics (JBM 3/14)
   IMPLICIT NONE
   ! ======================================================================
@@ -34,4 +35,5 @@
 
   include "YOMCST.h"
+  include "nuage.h" ! JBM 3/14
 
   ! ym#include "dimensions.h"
@@ -54,14 +56,20 @@
   REAL zflwp, zradef, zfice, zmsac
 
-  REAL radius, rad_froid, rad_chaud, rad_chau1, rad_chau2
-  PARAMETER (rad_chau1=13.0, rad_chau2=9.0, rad_froid=35.0)
+  REAL radius, rad_chaud
+! JBM (3/14) parameters already defined in nuage.h:
+! REAL rad_froid, rad_chau1, rad_chau2
+! PARAMETER (rad_chau1=13.0, rad_chau2=9.0, rad_froid=35.0)
   ! cc      PARAMETER (rad_chaud=15.0, rad_froid=35.0)
   ! sintex initial      PARAMETER (rad_chaud=10.0, rad_froid=30.0)
   REAL coef, coef_froi, coef_chau
   PARAMETER (coef_chau=0.13, coef_froi=0.09)
-  REAL seuil_neb, t_glace
-  PARAMETER (seuil_neb=0.001, t_glace=273.0-15.0)
-  INTEGER nexpo ! exponentiel pour glace/eau
-  PARAMETER (nexpo=6)
+  REAL seuil_neb
+  PARAMETER (seuil_neb=0.001)
+! JBM (3/14) nexpo is replaced by exposant_glace
+! REAL nexpo ! exponentiel pour glace/eau
+! PARAMETER (nexpo=6.)
+  REAL, PARAMETER :: t_glace_min_old = 258.
+  INTEGER, PARAMETER :: exposant_glace_old = 6
+
 
   ! jq for the aerosol indirect effect
@@ -96,7 +104,13 @@
       pclc(i, k) = max(pclc(i,k), seuil_neb)
       zflwp = 1000.*pqlwp(i, k)/rg/pclc(i, k)*(paprs(i,k)-paprs(i,k+1))
-      zfice = 1.0 - (t(i,k)-t_glace)/(273.13-t_glace)
-      zfice = min(max(zfice,0.0), 1.0)
-      zfice = zfice**nexpo
+      IF (iflag_t_glace.EQ.0) THEN
+        zfice = 1.0 - (t(i,k)-t_glace_min_old)/(273.13-t_glace_min_old)
+        zfice = min(max(zfice,0.0), 1.0)
+        zfice = zfice**exposant_glace_old
+      ELSE ! of IF (iflag_t_glace.EQ.0)
+! JBM: icefrac_lsc is now a function contained in microphys_mod
+        zfice = icefrac_lsc(t(i,k), t_glace_min, &
+                            t_glace_max, exposant_glace)
+      ENDIF
 
       IF (ok_aie) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/nuage.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/nuage.h	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/nuage.h	(revision 2056)
@@ -3,7 +3,11 @@
 !
       REAL rad_froid, rad_chau1, rad_chau2, t_glace_max, t_glace_min
+      REAL exposant_glace
       REAL rei_min,rei_max
 
+      INTEGER iflag_t_glace
+
       common /nuagecom/ rad_froid,rad_chau1, rad_chau2,t_glace_max,     &
-     &                  t_glace_min,rei_min,rei_max
+     &                  t_glace_min,exposant_glace,rei_min,rei_max,     &
+     &                  iflag_t_glace
 !$OMP THREADPRIVATE(/nuagecom/)
Index: /LMDZ5/branches/testing/libf/phylmd/oasis.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/oasis.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/oasis.F90	(revision 2056)
@@ -96,4 +96,8 @@
     USE surface_data, ONLY : version_ocean
     USE carbon_cycle_mod, ONLY : carbon_cycle_cpl
+#ifdef CPP_XIOS
+    USE wxios, ONLY : wxios_context_init 
+#endif
+
 
     INCLUDE "dimensions.h"
@@ -128,5 +132,5 @@
 ! Define the model name
 !
-    clmodnam = 'lmdz.x'       ! as in $NBMODEL in Cpl/Nam/namcouple.tmp
+    clmodnam = 'LMDZ'       ! as in $NBMODEL in Cpl/Nam/namcouple.tmp
 
 
@@ -298,4 +302,8 @@
     ENDIF
 
+#ifdef CPP_XIOS
+    CALL wxios_context_init()
+#endif
+
 !$OMP END MASTER
     
Index: /LMDZ5/branches/testing/libf/phylmd/orografi_strato.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/orografi_strato.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/orografi_strato.F90	(revision 2056)
@@ -1873,4 +1873,5 @@
   PRINT *, ' DANS SUGWD nktopg=', nktopg
   PRINT *, ' DANS SUGWD nstra=', nstra
+  if (nstra == 0) call abort_gcm("sugwd_strato", "no level in stratosphere", 1)
 
   gsigcr = 0.80
Index: /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2056)
@@ -195,6 +195,6 @@
              'coherente ', i, zmasq(i) , pctsrf(i, is_oce) &
              , pctsrf(i, is_sic)
-        WRITE(*, *) 'Je force la coherence zmasq=fractint'
-        zmasq(i) = fractint(i)
+        WRITE(*, *) 'Je force la coherence zmasq=1.-fractint'
+        zmasq(i) = 1. - fractint(i)
      ENDIF
   END DO
@@ -1048,6 +1048,4 @@
   CALL close_startphy
 
-  CALL init_iophy_new(rlat, rlon)
-
   ! Initialize module pbl_surface_mod 
 
@@ -1060,6 +1058,7 @@
   ENDIF
 
+  CALL init_iophy_new(rlat, rlon)
+
   ! Initilialize module fonte_neige_mod      
-
   CALL fonte_neige_init(run_off_lic_0)
 
Index: /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2056)
@@ -334,6 +334,9 @@
       allocate(topswcf_aero(klon,3), solswcf_aero(klon,3))
       allocate(d_u_hin(klon,klev),d_v_hin(klon,klev),d_t_hin(klon,klev))
-      allocate(tausum_aero(klon,nwave,naero_spc))
-      allocate(tau3d_aero(klon,klev,nwave,naero_spc)) 
+!      allocate(tausum_aero(klon,nwave,naero_spc))
+!      allocate(tau3d_aero(klon,klev,nwave,naero_spc)) 
+!--correction mini bug OB
+      allocate(tausum_aero(klon,nwave,naero_tot))
+      allocate(tau3d_aero(klon,klev,nwave,naero_tot)) 
       allocate(scdnc(klon, klev))
       allocate(cldncl(klon))
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2056)
@@ -3,5 +3,5 @@
   USE phys_output_var_mod
   USE indice_sol_mod
-  USE aero_mod, only : naero_spc,name_aero
+  USE aero_mod, only : naero_tot,name_aero_tau
 
 
@@ -237,5 +237,7 @@
     'bils_diss', 'Surf. total heat flux', 'W/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_bils_ec = ctrl_out((/ 1, 2, 10, 5, 10, 10, 11, 11, 11 /), &
-    'bils_ec', 'Surf. total heat flux', 'W/m2', (/ ('', i=1, 9) /))
+    'bils_ec', 'Surf. total heat flux correction', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_bils_ech = ctrl_out((/ 1, 2, 10, 5, 10, 10, 11, 11, 11 /), &
+    'bils_ech', 'Surf. total heat flux correction', 'W/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_bils_kinetic = ctrl_out((/ 1, 2, 10, 5, 10, 10, 11, 11, 11 /), &
     'bils_kinetic', 'Surf. total heat flux', 'W/m2', (/ ('', i=1, 9) /))
@@ -723,29 +725,28 @@
     'solswai', 'AIE at SFR', 'W/m2', (/ ('', i=1, 9) /))
 
-!  type(ctrl_out),save,dimension(10) :: o_tausumaero  = (/ ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASBCM', &
-!    (/ ('', i=1, 9) /)), &
-  type(ctrl_out),save,dimension(11) :: o_tausumaero  =                           & 
+  type(ctrl_out),save,dimension(naero_tot) :: o_tausumaero  =                           & 
     (/ ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASBCM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(1),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(1),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASPOMM',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero(2),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(2),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASSO4M',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero(3),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(3),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CSSO4M',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero(4),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(4),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_SSSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(5),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(5),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_ASSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(6),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(6),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CSSSM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(7),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(7),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_CIDUSTM',                      &
-      "Aerosol Optical depth at 550 nm "//name_aero(8),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(8),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_AIBCM',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(9),"1", (/ ('', i=1, 9) /)), &
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(9),"1", (/ ('', i=1, 9) /)), &
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_AIPOMM',                       &
-      "Aerosol Optical depth at 550 nm "//name_aero(10),"1", (/ ('', i=1, 9) /)),&
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(10),"1", (/ ('', i=1, 9) /)),&
        ctrl_out((/ 2, 2, 10, 10, 10, 10, 11, 11, 11 /),'OD550_STRAT',                        &
-      "Aerosol Optical depth at 550 nm "//name_aero(11),"1", (/ ('', i=1, 9) /)) /)
+      "Aerosol Optical depth at 550 nm "//name_aero_tau(11),"1", (/ ('', i=1, 9) /)) /)
+!
   TYPE(ctrl_out), SAVE :: o_od550aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
     'od550aer', 'Total aerosol optical depth at 550nm', '-', (/ ('', i=1, 9) /))
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2056)
@@ -26,6 +26,5 @@
 
   SUBROUTINE phys_output_open(rlon,rlat,pim,tabij,ipt,jpt,plon,plat, &
-       jjmp1,nlevSTD,clevSTD,rlevSTD,nbteta, &
-       ctetaSTD, dtime, ok_veget, &
+       jjmp1,nlevSTD,clevSTD,rlevSTD, dtime, ok_veget, &
        type_ocean, iflag_pbl,ok_mensuel,ok_journe, &
        ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, read_climoz, &
@@ -82,5 +81,5 @@
 
     INTEGER                               :: jjmp1
-    INTEGER                               :: nbteta, nlevSTD, radpas
+    INTEGER                               :: nlevSTD, radpas
     LOGICAL                               :: ok_mensuel, ok_journe, ok_hf, ok_instan
     LOGICAL                               :: ok_LES,ok_ade,ok_aie,flag_aerosol_strat
@@ -106,5 +105,4 @@
     CHARACTER(LEN=2)                      :: bb3
     CHARACTER(LEN=6)                      :: type_ocean
-    CHARACTER(LEN=3)                      :: ctetaSTD(nbteta)
     INTEGER, DIMENSION(iim*jjmp1)         ::  ndex2d
     INTEGER, DIMENSION(iim*jjmp1*klev)    :: ndex3d
@@ -306,20 +304,25 @@
 #ifdef CPP_XIOS
 !!! Ouverture de chaque fichier XIOS !!!!!!!!!!!
+    if (prt_level >= 10) then
+      print*,'phys_output_open: call wxios_add_file with phys_out_filenames(iff)=',trim(phys_out_filenames(iff))                                                                        
+    endif
     CALL wxios_add_file(phys_out_filenames(iff),chtimestep(iff),lev_files(iff))  
-    print*,'wxios_add_file phys_out_filenames(iff)',phys_out_filenames(iff)                                                                        
 
 !!! Declaration des axes verticaux de chaque fichier:
-    print*,'Declaration des axes verticaux de chaque fichier '
+    if (prt_level >= 10) then
+      print*,'phys_output_open: Declare vertical axes for each file'
+    endif
    if (iff.le.6) then
-    CALL wxios_add_vaxis("presnivs", phys_out_filenames(iff), &
+    CALL wxios_add_vaxis("presnivs", &
             levmax(iff) - levmin(iff) + 1, presnivs(levmin(iff):levmax(iff)))
-    CALL wxios_add_vaxis("Ahyb", phys_out_filenames(iff), &
+    CALL wxios_add_vaxis("Ahyb", &
             levmax(iff) - levmin(iff) + 1, Ahyb)
-    CALL wxios_add_vaxis("Bhyb", phys_out_filenames(iff), &
+    CALL wxios_add_vaxis("Bhyb", &
             levmax(iff) - levmin(iff) + 1, Bhyb)
-    CALL wxios_add_vaxis("Ahyb", phys_out_filenames(iff), &
+    CALL wxios_add_vaxis("Alt", &
             levmax(iff) - levmin(iff) + 1, Alt)
    else
-    CALL wxios_add_vaxis("plev", phys_out_filenames(iff), &
+    ! NMC files
+    CALL wxios_add_vaxis("plev", &
             levmax(iff) - levmin(iff) + 1, rlevSTD(levmin(iff):levmax(iff)))
    endif
@@ -362,6 +365,8 @@
           else IF (clef_stations(iff)) THEN
 
-             WRITE(lunout,*)'phys_output_mod phys_out_filenames=',phys_out_filenames(iff)
-
+             if (prt_level >= 10) then
+             WRITE(lunout,*)'phys_output_open: iff=',iff,'  phys_out_filenames(iff)=',phys_out_filenames(iff)
+             endif
+             
              CALL histbeg_phy_all(rlon,rlat,pim,tabij,ipt,jpt,plon,plat,plon_bounds,plat_bounds, &
                   phys_out_filenames(iff), &
@@ -491,6 +496,8 @@
     ecrit_ins = ecrit_files(6)
 
-    WRITE(lunout,*)'swaero_diag=',swaero_diag
-    WRITE(lunout,*)'Fin phys_output_mod.F90'
+    if (prt_level >= 10) then
+      WRITE(lunout,*)'swaero_diag=',swaero_diag
+      WRITE(lunout,*)'phys_output_open: ends here'
+    endif
 
   end SUBROUTINE phys_output_open
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2056)
@@ -17,4 +17,5 @@
   !$OMP THREADPRIVATE(itau_con)
   REAL, ALLOCATABLE :: bils_ec(:) ! Contribution of energy conservation
+  REAL, ALLOCATABLE :: bils_ech(:) ! Contribution of energy conservation
   REAL, ALLOCATABLE :: bils_tke(:) ! Contribution of energy conservation
   REAL, ALLOCATABLE :: bils_diss(:) ! Contribution of energy conservation
@@ -22,5 +23,5 @@
   REAL, ALLOCATABLE :: bils_enthalp(:) ! bilan de chaleur au sol
   REAL, ALLOCATABLE :: bils_latent(:) ! bilan de chaleur au sol
-  !$OMP THREADPRIVATE(bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+  !$OMP THREADPRIVATE(bils_ec,bils_ech,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
 
 
@@ -83,5 +84,5 @@
     allocate(snow_o(klon), zfra_o(klon))
     allocate(itau_con(klon))
-    allocate (bils_ec(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
+    allocate (bils_ec(klon),bils_ech(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
 
     IF (ok_gwd_rando) allocate(zustr_gwd_rando(klon), zvstr_gwd_rando(klon))
@@ -95,5 +96,5 @@
 
     deallocate(snow_o,zfra_o,itau_con)
-    deallocate (bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+    deallocate (bils_ec,bils_ech,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
 
   END SUBROUTINE phys_output_var_end
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2056)
@@ -19,5 +19,5 @@
        ok_ade, ok_aie, ivap, new_aod, ok_sync, &
        ptconv, read_climoz, clevSTD, ptconvth, &
-       d_t, qx, d_qx, zmasse, flag_aerosol_strat)
+       d_t, qx, d_qx, zmasse, flag_aerosol, flag_aerosol_strat, ok_cdnc)
 
     ! This subroutine does the actual writing of diagnostics that were
@@ -45,5 +45,5 @@
          o_LWupSFC, o_LWdnSFC, o_LWupSFCclr, &
          o_LWdnSFCclr, o_bils, o_bils_diss, &
-         o_bils_ec, o_bils_tke, o_bils_kinetic, &
+         o_bils_ec,o_bils_ech, o_bils_tke, o_bils_kinetic, &
          o_bils_latent, o_bils_enthalp, o_sens, &
          o_fder, o_ffonte, o_fqcalving, o_fqfonte, &
@@ -217,5 +217,5 @@
 
     USE phys_output_var_mod, only: vars_defined, snow_o, zfra_o, bils_diss, &
-         bils_ec, bils_tke, bils_kinetic, bils_latent, bils_enthalp, &
+         bils_ec,bils_ech, bils_tke, bils_kinetic, bils_latent, bils_enthalp, &
          itau_con, nfiles, clef_files, nid_files, zvstr_gwd_rando
     USE indice_sol_mod, only: nbsrf
@@ -223,5 +223,6 @@
     USE comgeomphy, only: airephy
     USE surface_data, only: type_ocean, ok_veget, ok_snow
-    USE aero_mod, only: naero_spc
+!    USE aero_mod, only: naero_spc
+    USE aero_mod, only: naero_tot
     USE ioipsl, only: histend, histsync
     USE iophy, only: set_itau_iophy, histwrite_phy
@@ -230,5 +231,6 @@
 #ifdef CPP_XIOS
     ! ug Pour les sorties XIOS
-    USE wxios, only: wxios_update_calendar, wxios_closedef
+    USE xios, ONLY: xios_update_calendar
+    USE wxios, only: wxios_closedef
 #endif
     USE phys_cal_mod, only : mth_len
@@ -259,4 +261,6 @@
     REAL, DIMENSION(klon, llm) :: zmasse
     LOGICAL :: flag_aerosol_strat
+    INTEGER :: flag_aerosol 
+    LOGICAL :: ok_cdnc
     REAL, DIMENSION(3) :: freq_moyNMC
 
@@ -292,7 +296,7 @@
        IF (vars_defined) THEN
           if (prt_level >= 10) then
-             write(lunout,*)"phys_output_write: call wxios_update_calendar, itau_w=",itau_w
+             write(lunout,*)"phys_output_write: call xios_update_calendar, itau_w=",itau_w
           endif
-          CALL wxios_update_calendar(itau_w)
+          CALL xios_update_calendar(itau_w)
        END IF
        !$OMP END MASTER
@@ -463,4 +467,7 @@
        CALL histwrite_phy(o_bils_diss, bils_diss)
        CALL histwrite_phy(o_bils_ec, bils_ec)
+       IF (iflag_ener_conserv>=1) THEN
+         CALL histwrite_phy(o_bils_ech, bils_ech)
+       ENDIF
        CALL histwrite_phy(o_bils_tke, bils_tke)
        CALL histwrite_phy(o_bils_kinetic, bils_kinetic)
@@ -770,5 +777,5 @@
        ! OD550 per species
        IF (new_aod .and. (.not. aerosol_couple)) THEN
-          IF (ok_ade.OR.ok_aie) THEN
+          IF (flag_aerosol.GT.0) THEN
              CALL histwrite_phy(o_od550aer, od550aer)
              CALL histwrite_phy(o_od865aer, od865aer)
@@ -792,6 +799,8 @@
              !--STRAT AER
           ENDIF
-          IF (ok_ade.OR.ok_aie.OR.flag_aerosol_strat) THEN
-             DO naero = 1, naero_spc
+          IF (flag_aerosol.GT.0.OR.flag_aerosol_strat) THEN
+!             DO naero = 1, naero_spc
+!--correction mini bug OB
+             DO naero = 1, naero_tot
                 CALL histwrite_phy(o_tausumaero(naero), &
                      tausum_aero(:,2,naero) )
@@ -830,4 +839,6 @@
           CALL histwrite_phy(o_topswai, topswai_aero)
           CALL histwrite_phy(o_solswai, solswai_aero)
+       ENDIF
+       IF (flag_aerosol.GT.0.AND.ok_cdnc) THEN
           CALL histwrite_phy(o_scdnc, scdnc)
           CALL histwrite_phy(o_cldncl, cldncl)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2055)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2056)
@@ -349,4 +349,6 @@
       REAL,SAVE,ALLOCATABLE :: tau_aero(:,:,:,:), piz_aero(:,:,:,:), cg_aero(:,:,:,:)
 !$OMP THREADPRIVATE(tau_aero, piz_aero, cg_aero)
+      REAL,SAVE,ALLOCATABLE :: tau_aero_rrtm(:,:,:,:), piz_aero_rrtm(:,:,:,:), cg_aero_rrtm(:,:,:,:)
+!$OMP THREADPRIVATE(tau_aero_rrtm, piz_aero_rrtm, cg_aero_rrtm)
       REAL,SAVE,ALLOCATABLE :: ccm(:,:,:)
 !$OMP THREADPRIVATE(ccm)
@@ -517,4 +519,6 @@
       ALLOCATE(topswai(klon), solswai(klon))
       ALLOCATE(tau_aero(klon,klev,naero_grp,nbands),piz_aero(klon,klev,naero_grp,nbands),cg_aero(klon,klev,naero_grp,nbands))
+      ALLOCATE(tau_aero_rrtm(klon,klev,2,nbands_rrtm),piz_aero_rrtm(klon,klev,2,nbands_rrtm))
+      ALLOCATE(cg_aero_rrtm(klon,klev,2,nbands_rrtm))
       ALLOCATE(ccm(klon,klev,nbands))
 
@@ -631,4 +635,5 @@
       deallocate(topswai, solswai)
       deallocate(tau_aero,piz_aero,cg_aero)
+      deallocate(tau_aero_rrtm,piz_aero_rrtm,cg_aero_rrtm)
       deallocate(ccm)
       if (ok_gwd_rando) deallocate(du_gwd_rando, dv_gwd_rando)
